﻿Imports System.Runtime.CompilerServices

Module ArrayExtensions
    ' Copy the indicated entries from an array into a new array.
    <Extension()> _
    Public Function SubArray(Of T)(ByVal values() As T, ByVal start_index As Integer, ByVal end_index As Integer) As T()
        Dim num_items As Integer = end_index - start_index + 1
        Dim result(0 To num_items - 1) As T
        Array.Copy(values, start_index, result, 0, num_items)
        Return result
    End Function

    <Extension()> _
    Public Function SubArray(Of T)(ByVal values(,) As T, ByVal row_min As Integer, ByVal row_max As Integer, ByVal col_min As Integer, ByVal col_max As Integer) As T(,)
        Dim num_rows As Integer = row_max - row_min + 1
        Dim num_cols As Integer = col_max - col_min + 1
        Dim result(0 To num_rows - 1, 0 To num_cols - 1) As T

        For row As Integer = 0 To num_rows - 1
            For col As Integer = 0 To num_cols - 1
                result(row, col) = values(row + row_min, col + col_min)
            Next col
        Next row

        Return result
    End Function
End Module
